package oop.demo2;

import oop.Demo;
import javax.microedition.lcdui.*;

/**
 * @author aNNiMON
 */
public class OopMenu3 extends Canvas {
    
    private final int width, height;
    
    private int cursor;
    private MenuItem[] items;

    public OopMenu3() {
        setFullScreenMode(true);
        width = getWidth();
        height = getHeight();
        
        cursor = 0;
        items = new MenuItem[] {
            new IconMenuItem("Start", "start.png"),
            new ColorMenuItem("Options", 0xFFA06028),
            new ColorMenuItem("Help", 0xFF3C3A83),
            new MenuItem("About"),
            new IconMenuItem("Exit", "exit.png")
        };
    } 
    
    public void paint(Graphics g) {
        g.setColor(0xFFE1FFE1);
        g.fillRect(0, 0, width, height);
        // Draw menu
        g.setColor(0xFF095E15);
        final int itemHeight = g.getFont().getHeight() + 5;
        final int startY = height - itemHeight * items.length;
        for (int i = 0; i < items.length; i++) {
            MenuItem item = items[i];
            if (item instanceof IconMenuItem) {
                g.drawImage(((IconMenuItem) item).getIcon(), width / 4, startY + itemHeight * i, Graphics.TOP | Graphics.RIGHT);
            } else if (item instanceof ColorMenuItem) {
                g.setColor(((ColorMenuItem)item).getColor());
            } else {
                // item - MenuItem
                g.setColor(0xFF095E15);
            }
            g.drawString(items[i].getName(), width / 2, startY + itemHeight * i, Graphics.TOP | Graphics.HCENTER);
        }
        // Draw cursor
        g.setColor(0xFF11C62A);
        g.drawRect(0, startY + itemHeight * cursor, width, itemHeight);
    }
    
    protected void keyPressed(int keyCode) {
        final int ga = getGameAction(keyCode);
        switch (ga) {
            case UP:
                cursor--;
                if (cursor < 0) cursor = items.length - 1;
                break;
            case DOWN:
                cursor++;
                if (cursor >= items.length) cursor = 0;
                break;
            case FIRE:
                Alert al = new Alert("Info");
                al.setString(items[cursor].getName() + "\n" + items[cursor].getClass().getName());
                Demo.midlet.dsp.setCurrent(al);
                break;
        }
        repaint();
    }

}